import java.io.*;
import java.util.*;

public class veryimportantedge_xiaowuc1 {

  static int[] uf;
  static int[] start, nextID;
  static long[] edges;

  static int[] treedepth, treesz, treepar, treetop;
  static int[] vertextoid;

  public static void main(String[] args) throws IOException {
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    PrintWriter pw = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
    StringTokenizer st = new StringTokenizer(br.readLine());
    int n = Integer.parseInt(st.nextToken());
    int m = Integer.parseInt(st.nextToken());
    start = new int[n];
    Arrays.fill(start, -1);
    nextID = new int[2*n-2];
    edges = new long[2*n-2];
    uf = new int[n];
    Arrays.fill(uf, -1);
    long[] mstcands = new long[m];
    for(int i = 0; i < m; i++) {
      st = new StringTokenizer(br.readLine());
      int a = Integer.parseInt(st.nextToken())-1;
      int b = Integer.parseInt(st.nextToken())-1;
      int w = Integer.parseInt(st.nextToken());
      mstcands[i] = w;
      mstcands[i] <<= 20;
      mstcands[i] |= a;
      mstcands[i] <<= 20;
      mstcands[i] |= b;
    }
    Arrays.sort(mstcands);
    boolean[] inmst = new boolean[m];
    long base = 0;
    {
      int eidx = -1;
      int idx = 0;
      for(long out: mstcands) {
        eidx++;
        int b = (int)(out & (1048575));
        int a = (int)((out>>20) & (1048575));
        int w = (int)((out>>40) & (1048575));
        if(!merge(a, b)) continue;
        base += w;
        inmst[eidx] = true;
        edges[2*idx] = w | (((long)b) << 20);
        edges[2*idx+1] = w | (((long)a) << 20);
        nextID[2*idx] = start[a];
        start[a] = 2*idx;
        nextID[2*idx+1] = start[b];
        start[b] = 2*idx+1;
        if(++idx == n-1) break;
      }
      if(idx != n-1) throw new RuntimeException();
    }
    treesz = new int[n];
    treedepth = new int[n];
    treepar = new int[n];
    treetop = new int[n];
    vertextoid = new int[n];
    Arrays.fill(treesz, 1);
    dfsforsz(0, -1);
    dfsforhldinit(0, 0);
    SZ = 1;
    while(SZ < n) SZ *= 2;
    seg = new int[2*SZ];
    Arrays.fill(seg, 1<<30);
    for(int i = 0; i < m; i++) {
      if(inmst[i]) continue;
      int b = (int)(mstcands[i] & (1048575));
      int a = (int)((mstcands[i]>>20) & (1048575));
      int w = (int)((mstcands[i]>>40) & (1048575));
      pathupd(a, b, w);
    }
    for(int i = 1; i < SZ; i++) {
      seg[2*i] = Math.min(seg[2*i], seg[i]);
      seg[2*i+1] = Math.min(seg[2*i+1], seg[i]);
    }
    int ret = 0;
    for(int i = 0; i < m; i++) {
      if(inmst[i]) {
        int b = (int)(mstcands[i] & (1048575));
        int a = (int)((mstcands[i]>>20) & (1048575));
        int w = (int)((mstcands[i]>>40) & (1048575));
        int biggerchild = treedepth[a] > treedepth[b] ? a : b;
        ret = Math.max(ret, seg[vertextoid[biggerchild]+SZ] - w);
      }
    }
    pw.println(base+ret);
    pw.close();
  }

  static int[] seg;
  static int SZ;
  private static void hldupd(int lhs, int rhs, int w) {
    lhs += SZ;
    rhs += SZ;
    while(lhs <= rhs) {
      if(lhs%2!=0) {
        seg[lhs] = Math.min(seg[lhs], w);
        lhs++;
      }
      if(rhs%2==0) {
        seg[rhs] = Math.min(seg[rhs], w);
        rhs--;
      }
      lhs /= 2;
      rhs /= 2;
    }
  }

  private static void pathupd(int a, int b, int w) {
    while(treetop[a] != treetop[b]) {
      if(treedepth[treetop[a]] < treedepth[treetop[b]]) {
        a ^= b;
        b ^= a;
        a ^= b;
      }
      int na = treetop[a];
      int up = treedepth[a] - treedepth[na];
      hldupd(vertextoid[a] - up, vertextoid[a], w);
      a = treepar[na];
    }
    if(treedepth[a] > treedepth[b]) {
      a ^= b;
      b ^= a;
      a ^= b;
    }
    int up = treedepth[b] - treedepth[a];
    hldupd(vertextoid[b] - up + 1, vertextoid[b], w);
  }

  static int _hldinitidx;
  private static void dfsforhldinit(int curr, int top) {
    treetop[curr] = top;
    vertextoid[curr] = _hldinitidx++;
    int bestchild = -1;
    int idx = start[curr];
    while(idx != -1) {
      int child = (int)(edges[idx] >> 20);
      if(treesz[child] < treesz[curr]) {
        if(bestchild == -1 || treesz[child] > treesz[bestchild]) bestchild = child;
      }
      idx = nextID[idx];
    }
    if(bestchild == -1) return;
    dfsforhldinit(bestchild, top);
    idx = start[curr];
    while(idx != -1) {
      int child = (int)(edges[idx] >> 20);
      if(treesz[child] < treesz[curr] && child != bestchild) dfsforhldinit(child, child);
      idx = nextID[idx];
    }
  }

  private static void dfsforsz(int curr, int par) {
    int idx = start[curr];
    while(idx != -1) {
      int child = (int)(edges[idx] >> 20);
      if(child != par) {
        treedepth[child] = treedepth[curr] + 1;
        treepar[child] = curr;
        dfsforsz(child, curr);
        treesz[curr] += treesz[child];
      }
      idx = nextID[idx];
    }
  }

  private static boolean merge(int x, int y) {
    x = find(x);
    y = find(y);
    if(x == y) return false;
    uf[x] = y;
    return true;
  }

  private static int find(int x) {
    if(uf[x] < 0) return x;
    return uf[x] = find(uf[x]);
  }

};